
-- new stuff

script.on_init(function ()
  init_tat()
  printAll("init_tat")
end)

script.on_event(defines.events.on_chunk_generated, function (event)
	chunk_generated_handler(event)
  --printAll("chunk_generated_handler")
end)


 -- start
 local file_name = "trees-and-terrains.lua"
 
function init_tat()
  if not global then global = {} end
	if not global.tat then global.tat = {} end
	if not global.tat.tree_names_list then global.tat.tree_names_list = {} end
	if not global.tat.terrain_names_list then global.tat.terrain_names_list = {} end
	if not global.tat.weight_table then global.tat.weight_table = {} end
	if not global.tat.export_must_be_updated then global.tat.export_must_be_updated = true end

end

function is_value_in_list(value, list)
  for i, v in pairs (list) do
    if v == value then 
      return true 
    end
  end
  return false
end

function chunk_generated_handler(event)
	local area = event.area
	local surface = event.surface
	local trees = surface.find_entities_filtered{area=area, type="tree"} -- don't forget surface!
	if (not trees) or (#trees == 0) then return end
  
	for i, tree in pairs (trees) do
    local tree_name = tree.name -- entity
    local position = tree.position
    local tile = surface.get_tile (tree.position)
    local tile_name = tile.name
    if not is_value_in_list(tile_name, global.tat.terrain_names_list) then
      global.tat.terrain_names_list[#global.tat.terrain_names_list+1] = tile_name
      global.tat.export_must_be_updated = true
      printAll("New terrain! - " .. tile_name)
    end
    if not is_value_in_list(tree_name, global.tat.tree_names_list) then
      global.tat.tree_names_list[#global.tat.tree_names_list+1] = tree_name
      global.tat.export_must_be_updated = true
      printAll("New tree! - " .. tree_name)
    end
    if not (global.tat.weight_table[tile_name]) then 
      global.tat.weight_table[tile_name] = {} 
      global.tat.weight_table[tile_name].name = tile_name
      global.tat.export_must_be_updated = true
      printAll("Added terrain to global - " .. tile_name)
    end
    if not (global.tat.weight_table[tile_name][tree_name]) then 
      global.tat.weight_table[tile_name][tree_name] = {tree_name = tree_name, tile_name = tile_name, weight = 1}
      global.tat.export_must_be_updated = true
      printAll("New tree " .. tree_name ..  " by terrain " .. tile_name)
    end
    local tile_tree_table = global.tat.weight_table[tile_name][tree_name]
    tile_tree_table.weight = tile_tree_table.weight + 1
	end
  
	if global.tat.export_must_be_updated then
		global.tat.export_must_be_updated = false
		export_iterator()
	end
end

function export_iterator()
	-- reset file
	game.write_file(file_name, "Table of terrains \n", false)
  
	for i, terrain in pairs (global.tat.weight_table) do
		string_to_file(terrain, true)
	end
end

function string_to_file(terrain_tabl, bool)
	--	terrains["grass-medium"] = {name = "grass-medium", trees = {"tree-04"}}
	local prefix = 'terrains["' .. terrain_tabl.name .. '"]'
	local suffix = serpent.block(terrain_tabl, {comment = false})
	local text_to_export = prefix .. " = " .. suffix .. ", \n"
	--if bool then printAll(text_to_export) end
	if bool then game.write_file(file_name, text_to_export, true) end
end

function printAll(text)
	if type(text) == "table" then text = serpent.block(text, {comment = false}) end
	for player_index, player in pairs (game.players) do 
    game.players[player_index].print (text) 
  end
end